<?php
/*
// "K2" Menu Category Module by Nicholas Lima for Joomla! 1.5.x - Version 2.0
// Copyright (c) 2009 Nicholas Lima - All rights reserved.
// Released under the GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
// More info at http://www.digietal.net
// Original Module Designed and developed by JoomlaWorks - This module is based on k2 Module from JoomlaWorks.
// *** Last update: AGO 24th, 2009 ***
*/


// no direct access
defined('_JEXEC') or die ('Restricted access');


require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');

class modK2menucatHelper {


	function hasChildren($id) {
	
		$user = & JFactory::getUser();
		$aid = $user->get('aid');
		$db = & JFactory::getDBO();
		$query = "SELECT * FROM #__k2_categories  WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
	
		if (count($rows)) {
			return true;
		}
		else {
			return false;
		}
	}
	
	
/** ESTRUTURA DO MENU **/
	

	function treerecurse( & $params, $id = 0, $level = 0, $begin=false) {
	
		static $output;
		if($begin){
			$output= '';
		}
		
		$root_id = $params->get('root_id');
		$end_level = $params->get('end_level',NULL);
		
		$catid = JRequest::getInt('id');
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');
	
		$user = & JFactory::getUser();
		$aid = $user->get('aid');
		$db = & JFactory::getDBO();
	
		switch($params->get('categoriesListOrdering'))
		{
		
			case 'alpha':
			$orderby = 'name';
			break;
		
			case 'ralpha':
			$orderby = 'name DESC';
			break;
		
			case 'order':
			$orderby = 'ordering';
			break;
		
			case 'reversedefault':
			$orderby = 'id DESC';
			break;
		
			default:
			$orderby = 'id ASC';
			break;
		}
	
		if (($root_id != 0) && ($level == 0)) {
			$query = "SELECT * FROM #__k2_categories WHERE parent={$root_id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY {$orderby}";
		
		}
		else {
			$query = "SELECT * FROM #__k2_categories WHERE parent={$id} AND published=1 AND trash=0 AND access<={$aid} ORDER BY {$orderby}";
		}
		
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		
		if ($level < intval($end_level) || is_null($end_level)) {
			$output .= '<ul '.($level == 0 ? 'id="menu_dropdown" ' : '').'class="level'.$level.'">';
			foreach ($rows as $row) {

				$countItems = modK2menucatHelper::countCategoryItems($row->id);

				if ($params->get('categoriesListItemsCounter')) {
					$row->numOfItems = ' ('.$countItems.')';
				}
				else {
					$row->numOfItems = '';
				}
			
				if (($option == 'com_k2') && ($view == 'itemlist') && ($catid == $row->id)) {
					$active = ' class="active"';
				}
				else {
					$active = '';
				}
			
				if (modK2menucatHelper::hasChildren($row->id)) {
					
					$output .= '<li class="submenu"><a href="'.urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($row->id.':'.urlencode($row->alias)))).'"><span>'.$row->name.$row->numOfItems.'</span></a>';
					modK2menucatHelper::treerecurse($params, $row->id, $level+1);
					$output .= '</li>';
				}
				else {
					$output .= '<li'.$active.'><a href="'.urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($row->id.':'.urlencode($row->alias)))).'"><span>'.$row->name.$row->numOfItems.'</span></a></li>';
				}

				If ($params->get('categoryItems') && $countItems) {
					$items = modK2menucatHelper::getCategoryItems($row->id, $params);

					$output.='<ul class="catItems">';
					foreach($items as $item) {
						if (($option == 'com_k2') && ($view == 'item') && ($catid == $row->id)) {
							$active = ' class="active"';
						}
						else {
							$active = '';
						}
						
						$output.= '<li'.$active.'><a href="'.urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias)))).'"><span class="catItem" id="catItem-'.$item->id.'">'.$item->title.'</span></a></li>';
						if ($params->get('itemImage')) {
							$output.='<div id="catItem-'.$item->id.'-img" class="hiddenImg"><img src="'.$item->image.'"/></div>';
						}	
					}

					$output .= '</ul>';

				}
			}
			$output .= '</ul>';
		}

		return $output;
	}

	function getCategoryChildren($catid) {
	
		static $array = array();
		$user = & JFactory::getUser();
		$aid = $user->get('aid');
		$db = & JFactory::getDBO();
		$query = "SELECT * FROM #__k2_categories WHERE parent={$catid} AND published=1 AND trash=0 AND access<={$aid} ORDER BY ordering ";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		if ($db->getErrorNum()) {
			echo $db->stderr();
			return false;
		}
		foreach ($rows as $row) {
			array_push($array, $row->id);
			if (modK2menucatHelper::hasChildren($row->id)) {
				modK2menucatHelper::getCategoryChildren($row->id);
			}
		}
		return $array;
	}

/** CONTADOR DE ITENS DA CATEGORIA **/

	function countCategoryItems($id) {
	
		$user = & JFactory::getUser();
		$aid = $user->get('aid');
		$db = & JFactory::getDBO();
		
		$jnow =& JFactory::getDate();
		$now = $jnow->toMySQL();
		$nullDate = $db->getNullDate();
		
		$query = "SELECT COUNT(*) FROM #__k2_items WHERE catid={$id} AND published=1 AND ( publish_up = ".$db->Quote($nullDate)." OR publish_up <= ".$db->Quote($now)." ) AND ( publish_down = ".$db->Quote($nullDate)." OR publish_down >= ".$db->Quote($now)." ) AND trash=0 AND access<={$aid}";
		$db->setQuery($query);
		$total = $db->loadResult();
		return $total;
	}

	function getCategoryItems($id, $params) {
	
		$user = & JFactory::getUser();
		$aid = $user->get('aid');
		$db = & JFactory::getDBO();
		
		$jnow =& JFactory::getDate();
		$now = $jnow->toMySQL();
		$nullDate = $db->getNullDate();
	
		switch($params->get('itemsListOrdering'))
                {

                        case 'alpha':
                        $orderby = 'title';
                        break;

                        case 'ralpha':
                        $orderby = 'title DESC';
                        break;

                        case 'order':
                        $orderby = 'ordering';
                        break;

                        case 'reversedefault':
                        $orderby = 'id DESC';
                        break;

                        default:
                        $orderby = 'id ASC';
                        break;
                }
	
		$query = "SELECT * FROM #__k2_items WHERE catid={$id} AND published=1 AND ( publish_up = ".$db->Quote($nullDate)." OR publish_up <= ".$db->Quote($now)." ) AND ( publish_down = ".$db->Quote($nullDate)." OR publish_down >= ".$db->Quote($now)." ) AND trash=0 AND access<={$aid} ORDER BY {$orderby}";

		$db->setQuery($query);
		$items = $db->loadObjectList();

		foreach ($items as & $item) {
			//Image
                	$item->image='';

	                if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_'.$params->get('itemImageSize').'.jpg'))
        	        $item->image = JURI::root().'media/k2/items/cache/'.md5("Image".$item->id).'_'.$params->get('itemImageSize').'.jpg';
		}

		return $items;
	}

}
?>
